#include <cstdio>

#define MAXN 20
#define MAXC 20 // C - colours

long long trees[MAXN]; //trees[i] - "how many binary trees can I make with i elements?"

int main()
{
	int N=0;
	char str[MAXN];
	scanf("%s", str);
	while(str[N]!='\0') N++;

	trees[0] = trees[1] = 1;
	for(int i=2; i<=MAXN; i++)
	{
		trees[i] = 0;
		for(int j=0; j<i; j++) // j - amount of right child nodes
			trees[i] += trees[j] * trees[(i-1)-j];
	}

	/*
	scanf("%d", &N);
	for(int i=0; i<N; i++) printf("%d ", trees[i]);
	printf("\n");
	*/

	long long sol45 = trees[N];

	const int POSSGROUPS=int('z'-'a')+1;
	long long count[POSSGROUPS],temp,max_count=0;
	//-----
	for(int i=0; i<POSSGROUPS; i++) count[i] = 0;

	for(N=0; str[N]!='\0'; N++)
	{
		temp = int(str[N]-'A');
		count[temp]++;
		if(count[temp] > count[max_count])
			max_count = temp;
	}

	temp=max_count;
	max_count = count[max_count];
	count[temp] = 0;

	long long sol90=1;
	for(long long i=N; i>max_count; i--)
	{
		sol90 *= i;
		//printf("%lld\n", sol45);
		for(int j=0; j<POSSGROUPS; j++)
		{
			while(count[j] && (sol90%count[j]==0))
			{
				sol90 /= count[j];
				count[j]--;
				//printf("%lld (%d)%lld\n", sol45, j,count[j]);
			}
		}
	}

	//-----


	//printf("%lld %lld\n", sol45,sol90);
	printf("%lld\n", sol45*sol90);




	/*
	for(int i=1; i<=N; i++)
		printf("%d ", trees[i]);
	printf("\n");
	*/


	return 0;
}
